//+------------------------------------------------------------------+
//|                                            Inzider EA v0.50f.mq4 |
//|                                         Copyright  2008 Inzider |
//|                                             Scipionz@hotmail.com |
//|                                                                  |
//| MACD and stochastics based Expert Advisor. This EA is meant      |
//| for 1 hour or 4 hour.                                            |
//+------------------------------------------------------------------+
//| This version trades at a NewBar and Elapsed Time                            |
//+------------------------------------------------------------------+
//| If you use this EA on more than one chart, or you have more than |
//| one EA on a given currency pair make sure to remember to change  |
//| the MagicNumber.                                                 |
//|                                                                  |
//| For Example: Inzider EA on 1 hour EUR/USD MagicNumber 255522     |
//| an also:     Inzider EA on 4 hour GBP/USD MagicNumber 211112     |
//|                                                                  |
//| It doesn't matter what you change the magic number to as long as |
//| it's unique. That way the expert won't effect itself on another  |
//| currency pair.                                                   |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008 Tom Balfe / Inzider"

//+------------------------------------------------------------------+
//| USER ADJUSTABLE STUFF                                            |
//+------------------------------------------------------------------+

extern  string  TopOfSetting          = "=== Inzider EA v.50f ===";
extern  int     MagicNumber           = 322522;
extern  int     WaitMinutes           = 10;
extern  bool    NewBar                = true; 

extern  string  Order_Settings        = "=== Order Settings ===";
extern  double  StaticLots            = 0.1;
extern  int     Slippage              = 3;
extern  int     TP                    = 50;
extern  int     SL                    = 75;

extern  string  MM_Settings           = "=== Money Management ===";
extern  bool    UseMM                 = false;
extern  int     PercentAtRisk         = 3;

extern  string  MACD_Settings         = "=== MACD Settings ===";
extern  int     FastEMA               = 20;
extern  int     SlowEMA               = 35;
extern  int     SMA                   = 9;

extern  string  Stoch_Settings        = "=== Stochastic Settings ===";
extern  int     PercentK              = 10;
extern  int     PercentD              = 3;
extern  int     Slowing               = 3;

extern  string  ADX_Settings          = "=== ADX Settings ===";
extern  int     ADXStrongTrend        = 21;

extern  string  TakeProfitManger      = "=== TakeProfitManger ===";
extern int First_Target = 20;
extern int Target_Increment = 20;
extern double Close_Lots = 0.1;
extern bool Move_Stops = false;
extern int First_Stop_Target = 10;
extern int First_Stop = 0;
extern int Second_Stop_Target = 30;
extern int Second_Stop = 10;
extern bool Use_Max_Loss = false;
extern int Max_Loss = 50;
extern int Magic_Number=0;

//=============== VARS internal
int nextTP;
bool sl;
int range = 5;
int multiplier;
// OrderType == 1 is OP_SELL

//+------------------------------------------------------------------+
//| DON'T CHANGE BELOW HERE                                          |
//+------------------------------------------------------------------+
//| Program initializes and deinitializes here.                      |
//+------------------------------------------------------------------+
string        EAComment   = "Inzider EA v50.f";
string        EATitle     = "INZIDER EA v0.50f  2008";
int           OpenOrders  = 1;
datetime      PreviousBar;

int init()
  {
  ObjectCreate("Title",OBJ_LABEL,0,0,0);
  ObjectSet("Title",OBJPROP_XDISTANCE,325);
  ObjectSet("Title",OBJPROP_YDISTANCE,2);
  ObjectSetText("Title",EATitle,9,"Lucida Sans Regular",PaleTurquoise);
  
  {
   sl=0;
   nextTP = First_Target;
   getMaxLoss();
  }

  return(0);
  }

int deinit()
  {
    if (TotalOpenOrders() > 0)
    {
    CloseAll();
       sl=0;
   nextTP = First_Target;
    } 
    
  ObjectsDeleteAll();
  ObjectDelete("Title");
     
  return(0);
  }
  
//+------------------------------------------------------------------+
//| MAIN LOOP                                                        |
//+------------------------------------------------------------------+
//| Program spends most of its life going through this main loop.    |
//+------------------------------------------------------------------+
int start()
  {
  
  //---Take profit
   getOpenOrders();
   getSpread();
   //Comment(sl);
   
   
  //--- MACD
  double MACDValue    = iMACD(NULL,0,FastEMA,SlowEMA,SMA,PRICE_MEDIAN,MODE_MAIN,0);
  double MACDSignal   = iMACD(NULL,0,FastEMA,SlowEMA,SMA,PRICE_MEDIAN,MODE_SIGNAL,0);
  
  //--- Stochastics
  double sMain        = iStochastic(NULL,0,PercentK,PercentD,Slowing,MODE_SMA,0,MODE_MAIN,0);
  double sSignal      = iStochastic(NULL,0,PercentK,PercentD,Slowing,MODE_SMA,0,MODE_SIGNAL,0);
  
    //--- Directional Index
  double adx          = iADX(NULL,0,14,PRICE_CLOSE,0,0); // ADX
  double di_p         = iADX(NULL,0,14,PRICE_CLOSE,1,0); // DI+ 
  double di_m         = iADX(NULL,0,14,PRICE_CLOSE,2,0); // DI-
   

//------------------- order management2 -------------------//

if (ElapsedTimeCheck(WaitMinutes) == true) {
  
    //---------------- check indicators and look for a CLOSE2 ---//
    if (TotalOpenOrders() == OpenOrders)
    {
      if (OrderType() == OP_BUY) {
        if (sMain<sSignal) { CloseAll(); }
        }
      if (OrderType() == OP_SELL) {
        if (sMain>sSignal) { CloseAll(); }
        }
    } // end of if we have orders
    
    //---------------- check indicators and look for a ORDER ENTRY ---//
    if (TotalOpenOrders() < OpenOrders)
    if (TotalOpenOrders() < OpenOrders)
    {
      if ((MACDValue>MACDSignal)&&(sMain>sSignal)&&(di_p>di_m)&&(adx>ADXStrongTrend)) // BUY
       {
       OrderSend(Symbol(),OP_BUY,LotSize(),Ask,Slippage,Ask-SL*Point,Ask+TP*Point,EAComment,MagicNumber,0,Lime);  
       } 
      if ((MACDValue<MACDSignal)&&(sMain<sSignal)&&(di_m>di_p)&&(adx>ADXStrongTrend)) // SELL
       {
       OrderSend(Symbol(),OP_SELL,LotSize(),Bid,Slippage,Bid+SL*Point,Ask-TP*Point,EAComment,MagicNumber,0,Red);
       }
    } // end of if no orders exist
  } // end of if newbar
  
  
   
   
   
  //------------------- order management -------------------//
  if (NewBar() == true) 
  
  {
  
    //---------------- check indicators and look for a CLOSE ---//
    if (TotalOpenOrders() == OpenOrders)
    {
      if (OrderType() == OP_BUY) {
        if (sMain<sSignal) { CloseAll(); }
        }
      if (OrderType() == OP_SELL) {
        if (sMain>sSignal) { CloseAll(); }
        }
    } // end of if we have orders
    
    //---------------- check indicators and look for a ORDER ENTRY ---//
    if (TotalOpenOrders() < OpenOrders)
    if (TotalOpenOrders() < OpenOrders)
    {
      if ((MACDValue>MACDSignal)&&(sMain>sSignal)&&(di_p>di_m)&&(adx>ADXStrongTrend)) // BUY
       {
       OrderSend(Symbol(),OP_BUY,LotSize(),Ask,Slippage,Ask-SL*Point,Ask+TP*Point,EAComment,MagicNumber,0,Lime);  
       } 
      if ((MACDValue<MACDSignal)&&(sMain<sSignal)&&(di_m>di_p)&&(adx>ADXStrongTrend)) // SELL
       {
       OrderSend(Symbol(),OP_SELL,LotSize(),Bid,Slippage,Bid+SL*Point,Ask-TP*Point,EAComment,MagicNumber,0,Red);
       }
    } // end of if no orders exist
  } // end of if newbar
  
  ShowInfo();

  return(0);



  } // end of main loop

//+------------------------------------------------------------------+
//| COMMON FUNCTIONS                                                 |
//+------------------------------------------------------------------+
//| The expert will call these from the main loop.                   |
//+------------------------------------------------------------------+

//+-----------------------------------------------------+
//|           new bar                                   |
//+-----------------------------------------------------+
bool NewBar()
{
  if(PreviousBar<Time[0])
  {
    PreviousBar = Time[0];
    return(true);
  }
  else
  {
    return(false);
  }
  return(false);  
}

//+-----------------------------------------------------+
//|           trade interval                            |
//+-----------------------------------------------------+
bool ElapsedTimeCheck(int mins)
{
  static datetime OldTime;
 
  if (OldTime == 0)
    OldTime = TimeCurrent() + mins * 60; // initialised once...

  if (TimeCurrent() >= OldTime) 
  {
    OldTime = TimeCurrent() + mins * 60;
    bool cond = true;
  }
  else cond = false;
 
 return(cond);
}

//+-----------------------------------------------------+
//|           calculate lot size                        |
//+-----------------------------------------------------+
double LotSize()
{
  if (UseMM == true) 
    { double Lots = MathCeil(AccountFreeMargin() *  PercentAtRisk / 1000) / 100; }
  
  else { Lots = StaticLots; }
  
  return(Lots);  
}

//+-----------------------------------------------------+
//|           close all                                 |
//+-----------------------------------------------------+
//| Finds any open orders & closes them                 |
//+-----------------------------------------------------+
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type = OrderType();
    
    if (OrderSymbol()==Symbol() && (OrderMagicNumber() == MagicNumber))  
    {
      //-- Close open BUYs
      if (type == OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,CornflowerBlue);
      //-- Close open SELLS
      if (type == OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,CornflowerBlue);
    }
  }
  return;
}

//+-----------------------------------------------------+
//|           calculate open orders                     |
//+-----------------------------------------------------+
int TotalOpenOrders()
{
  int j = 0;
  j=OrdersTotal();
  int TotalOpenOrders = 0;
   
  if(j==0) { return (0); }
  
  else
  {
    for(;j>=0;j--)
      {
      RefreshRates();
      OrderSelect(j,SELECT_BY_POS);
      if(OrderMagicNumber()==MagicNumber)
      {
        TotalOpenOrders++;
      }
    }
  }
  return(TotalOpenOrders);
}

//========== FUNCTION getPipValue
double getPipValue(double ord,int dir)
{
   double val;
   RefreshRates();
   if(dir == 1) val=(NormalizeDouble(ord,Digits) - NormalizeDouble(Ask,Digits));
   else val=(NormalizeDouble(Bid,Digits) - NormalizeDouble(ord,Digits));
   val = val/Point;
   return(val);   
}
//== end function

int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   return(spread);
}


int getMaxLoss()
{
   int calcMaxLoss;
   calcMaxLoss = Max_Loss;
   return(calcMaxLoss);
}
//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {  
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && OrderSymbol() == Symbol()&&(Magic_Number==0 || Magic_Number == OrderMagicNumber()))
         {

            double val=getPipValue(OrderOpenPrice(),OrderType());
            //int val = OrderProfit()/(OrderLots()*10);
            if(Use_Max_Loss && Max_Loss > 0) killTrade(val,OrderTicket());
            if(Move_Stops) checkStops(val,OrderTicket());
            takeProfit(val,OrderTicket());            
            
         }
         
         if(Magic_Number == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+Magic_Number;
         
         
         if(sl==0)
            {
               nsl = First_Stop_Target;
               nsd = First_Stop;
            }
          else
            {
               nsl = Second_Stop_Target;
               nsd = Second_Stop;
            }
         //RefreshRates();
         Comment("Order Open: ",OrderOpenPrice(), 
         "\nPip Count: ", val,
         "\nNext Stop Target: ",nsl,
         "\nNext Stop Differential: ", nsd,
         "\nNext TP: ", nextTP,
         "\nSL: ",sl,
         "\nMax Loss: ", getMaxLoss(),
         "\nManaging: ",mngMagic);
         

     }  
}

//========== FUNCTION takeProfit
void takeProfit(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {

      if(pips >= nextTP && pips < (nextTP + Target_Increment))
      {
         if(OrderType()==1)
         {
            if(OrderClose(ticket, Close_Lots, Ask, 3, YellowGreen))
            nextTP+=Target_Increment;
            else
            Print("Error closing order : ",GetLastError()); 
         } 
         else
         {
            if(OrderClose(ticket, Close_Lots, Bid, 3, YellowGreen))
            nextTP+=Target_Increment;
            else
            Print("Error closing order : ",GetLastError()); 
         }
              
      }

   }
}

//== end function



//========== FUNCTION moveStops
void checkStops(int pips,int ticket)
{
   if(sl==0 && pips < Second_Stop_Target)
   {
      if(pips >= First_Stop_Target && pips < (Second_Stop_Target))
      {
         moveStops(ticket, First_Stop);
      }
   }
   else if(sl==1 || pips >= Second_Stop_Target)
   {
      if(pips >= Second_Stop_Target)
      {
         moveStops(ticket,Second_Stop);
      }
   }


}

//== end function

//========== FUNCTION moveStops
void moveStops(int ticket,int stopDiff)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      Print("moveStops called ",ticket, " ",stopDiff);
      if(OrderType()==1) 
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-stopDiff*Point, OrderTakeProfit(),0,Plum);
      sl=1;
      }
      else 
      {
      OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+stopDiff*Point, OrderTakeProfit(),0,Plum);
      sl=1;
      }
   }
   

   
}

//== end function

//========== FUNCTION killTrades
void killTrade(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      if(pips <= -1*getMaxLoss())
      {
         if(OrderType()==1) OrderClose(ticket,OrderLots(),Ask,3,Red);     
         else OrderClose(ticket,OrderLots(),Bid,3,Red); 
      }      
   }
}
//== end function
//+-----------------------------------------------------+
//|           show summary panel on chart               |
//+-----------------------------------------------------+
void ShowInfo()
{
  Comment("...::: Inzider EA v0.50f :::...\n",
          "Copyright  2008 Inzider\n",
          "Currency Pair: ", Symbol(),"\n",
          "Price:  ",NormalizeDouble(Bid,4),"\n",
          "Date: ",Month(),"-",Day(),"-",Year()," Server Time: ",Hour(),":",Minute(),":",Seconds(),"\n",
          "Minimum Lot Size: ",MarketInfo(Symbol(),MODE_MINLOT));
  return(0);
}